package be.iminds.ilabt.jfed.ui.cli2.instruction;

import be.iminds.ilabt.jfed.experiment.setup.ExperimentSetupConfig;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

public class CreateSliceInstruction extends InstructionWithSlice {
    @JsonCreator
    public CreateSliceInstruction(@JsonProperty("action") @Nonnull Action action,
                                  @JsonProperty("user") @Nullable User user,
                                  @JsonProperty("actionOutputs") @Nullable List<ActionOutput> actionOutputs,
                                  @JsonProperty("debugOutputs") @Nullable List<DebugOutput> debugOutputs,
                                  @JsonProperty("callOutputs") @Nullable List<CallOutput> callOutputs,
                                  @JsonProperty("proxy") @Nullable ProxySettings proxy,
                                  @JsonProperty("slice") ExperimentSetupConfig.Slice slice) {
        super(action, user, actionOutputs, debugOutputs, callOutputs, proxy, slice);
    }

    private CreateSliceInstruction(boolean demo) {
        super(Action.CREATESLICE, demo, false);
    }

    @JsonIgnore
    @Nonnull
    @Override
    public Action getActionOfClass() {
        return Action.CREATESLICE;
    }
}
